//  Select value to display
var value = clamp(floor(256 * mouse_x / room_width), 0, 255);


//  Draw all digits for selected value
draw_set_color($FFFFFF);
draw_set_alpha(1.0);

// For each mode: unsigned, signed, hexadecimal, octal
for (var mode=0; mode<5; mode++) {
    // For each digit: 0-3
    for (var digit=0; digit<4; digit++) {
        var p = table[1024*mode + 256*digit + value];
        // For each display segment: 0-7
        for (var segment=0; segment<8; segment++) {
            if ((p >> segment) & 1) {
                draw_sprite(spr7seg, segments[segment], 48-16*digit, 32*mode);
            }
        }
    }
}


//  Select digit table to display
var col = mouse_x div 16;
var row = mouse_y div 32;


//  Highlight row and digit
gpu_set_blendmode_ext(bm_inv_dest_color, bm_zero);

var x0 = 16 * col;
var x1 = x0 + 15;
var y0 = 32 * row;
var y1 = y0 + 31;

draw_set_color($FFFF40);
draw_rectangle(0, y0, 63, y1, false);

if (col <= 3) {
    draw_set_color($FFFFFF);
    draw_rectangle(x0, y0, x1, y1, false);
}

gpu_set_blendmode(bm_normal);


//  Display digit table
var page = 1024 * clamp(row, 0, 7);
if (col >= 0 && col < 4) page += 256 * (3-col);

var text = "";
for (var j=0; j<32; j++) {
    for (var i=0; i<8; i++) {
        text += dec_to_hex(table[page + 8*j+i]);
        if (j < 31 || i < 7) text += ", ";
    }
    text += "\n";
}

draw_set_color($FFFFFF);
draw_set_font(font0);
draw_text(70, 0, text);
