/// @description Save ROM

if (keyboard_check(vk_control)) {
    
    //  Write raw ROM data
    var size = 4*4*256;
    var buffer = buffer_create(size, buffer_fixed, 1);
    for (i=0; i<size; i++) {
        buffer_poke(buffer, i, buffer_u8, table[i]);
    }
    buffer_save(buffer, "character-decoder.rom");
    buffer_delete(buffer);

    //  Write text dump of ROM for Logisim
    var fid = file_text_open_write("character-decoder.txt");
    file_text_write_string(fid, "v2.0 raw");
    file_text_writeln(fid);
    for (i=0; i<size; i++) {
        file_text_write_string(fid, dec_to_hex(table[i]));
        file_text_writeln(fid);
    }
    file_text_close(fid);
}